#!/bin/bash
scriptPath=$(dirname "$(realpath -s "$0")")
tsyncFile="tsync-4.0.4"
tsyncVersion="4.0.4"
tsyncPreviousVersion="4.0.3"

echo -n "Run 'bash part2.sh' before running this script.
Press Enter to continue with this script."
read var_name

echo "Installing build-essential dkms curl git unzip net-tools htop"
sudo apt update
sudo apt auto-remove -y
sudo apt auto-clean -y
sudo apt install -y build-essential dkms curl git unzip net-tools htop
sudo apt install linux-headers-$(uname -r) -y

unzip "$scriptPath/$tsyncFile.zip" -d /tmp/tsync

echo "Copying tsyncpci $tsyncVersion driver files"
sudo mkdir -p "/usr/src/tsyncpci-$tsyncVersion"

sudo cp -R /tmp/tsync/$tsyncFile/* "/usr/src/tsyncpci-$tsyncVersion"

sudo cp "$scriptPath/tsync-dkms.conf" "/usr/src/tsyncpci-$tsyncVersion/dkms.conf"

echo "Installing Tsync Utils"
make all -C "/tmp/tsync/$tsyncFile/"
sudo make install -C "/tmp/tsync/$tsyncFile/"

echo "Cleaning unarchived files"
sudo rm -rf /tmp/tsync

echo "Adding tsyncpci $tsyncVersion to DKMS"
sudo dkms add -m tsyncpci -v "$tsyncVersion"

echo "Installing tsyncpci $tsyncVersion"
sudo dkms install -m tsyncpci -v "$tsyncVersion"

echo "Configuring Tsync device permissions"
sudo cp "$scriptPath/51-tsyncpci.rules" "/etc/udev/rules.d/51-tsyncpci.rules"

echo "Disabling GNSS Reference on startup"
sudo cp "$scriptPath/disable-tsync-reference.sh" "/usr/local/sbin/disable-tsync-reference.sh"
sudo chmod u+x "/usr/local/sbin/disable-tsync-reference.sh"
sudo cp "$scriptPath/disable-tsync-reference.service" "/etc/systemd/system/disable-tsync-reference.service"
sudo systemctl start disable-tsync-reference
sudo systemctl enable disable-tsync-reference

echo "Rebooting"
reboot